desc 'Runs application tests.'
task :test do |t, args|
  puts 'Processing dependencies'
  require 'bundler'
  # Workaround for https://github.com/mkristian/jbundler/issues/59
  begin
    require 'bundler/vendor/thor/lib/thor/actions/create_file'
  rescue LoadError
    # Require is not valid for older versions of bundler
  end
  ENV['RACK_ENV'] = 'test'
  require 'bundler/cli'
  Bundler::CLI.start(['install'], :debug => false)
  Bundler.reset!

  puts 'Running tests'
  root_dir = File.expand_path('./')
  require 'rake/testtask'
  if (FileUtils::RUBY[/^file:.*.jar!/])
    # Fix for running tests with jruby-complete
    jar_path = FileUtils::RUBY.split('file:')[1].split('!')[0]
    FileUtils::RUBY = "java -jar #{jar_path}"
  end
  test_task = Rake::TestTask.new
  test_task.libs << File.join(root_dir , 'app')
  test_task.libs << File.join(root_dir , 'test')
  test_task.test_files = FileList["#{root_dir}/test/**/*test.rb", "#{root_dir}/test/**/test*.rb"]
  test_task.verbose = true
  test_task.run_code
end
