require 'uu/os/http/multipart_parser'
require 'uu/os/server/json_parser'

module UU
  module OS
    module Server
      # @private
      class MultipartParser

        def self.parse(request, opt = {})

          if request.content_type  =~ %r{.*boundary=([^;]+)}
            boundary = $1.strip
          else
            raise "Content-Type header do not contains required 'boundary' parameter."
          end

          parameters = {}
          binary_name = opt[:binary_name]

          UU::OS::HTTP::MultipartParser.parse_multipart(request.body, boundary, binary_name).each do |item|
            name = item[:name].to_sym
            body = item[:body]
            if item[:content_type] =~ %r{application/json} && body.kind_of?(String)
              parameters[name] = (UU::OS::Server::JsonParser.parse(body)  rescue body)
            else
              parameters[name] = body
            end

            if binary_name =~ %r{^#{name}$}
              parameters[:name] ||= item[:filename]
              parameters[:contentType] ||= item[:content_type]
            end
          end
          return parameters
        end

      end
    end
  end
end
