require 'rack/utils'
require 'uu/os/server/json_parser'

module UU
  module OS
    module Server
      # @private
      module QueryParser

        def self.parse(body)

          body = body.read if body.respond_to? :read
          return {} if body.nil? || body.empty?
          params = Rack::Utils.parse_nested_query(body, '&')
          params = params.inject({}) do |tmp, (key, value)|
            if value =~ /(^{.*}$)|(^\[.*\]$)/
              tmp[key.to_sym] = (UU::OS::Server::JsonParser.parse(value) rescue value)
            else
              tmp[key.to_sym] = value
            end
            tmp
          end
          return params
        end
      end
    end
  end
end
