require 'rack/utils'
require 'uu/os/http/http_request'

module UU
  module OS
    module Server

      # Class used for dynamic invocation of servlets so they
      # need not to implement Rack API.
      # @private
      class RackDispatcher # :nodoc:

        # Creates new instance of dispatcher.
        # @param [Rack::Builder] builder Instance of rack builder
        # @param [Class<UU::OS::Server::AbstractServlet>] servlet Servlet class.
        # @private
        def initialize(builder, servlet) # :nodoc:
          @servlet = servlet.new
        end

        # Main service method invoked by Rack framework.
        # @private
        def call(env) # :nodoc:
          request = UU::OS::Server::Request.new(env)
          @servlet.service(request)
        end

      end

    end
  end
end
